"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = require("fs");
const fs_extra_1 = require("fs-extra");
const glob = require("glob");
const path = require("path");
function copyTree(sourcePathAbs, destPathAbs, patterns = ["**/*"]) {
    return Promise.reject("not implemented yet");
}
exports.copyTree = copyTree;
function copyTreeSync(sourcePathAbs, destPathAbs, patterns = ["**/*"]) {
    patterns.forEach((pattern) => {
        glob.sync(path.resolve(sourcePathAbs, pattern), { nodir: true, absolute: true })
            .forEach((fileAbs) => {
            const relativePath = path.relative(sourcePathAbs, fileAbs);
            if (relativePath.indexOf("../") > -1 || path.isAbsolute(relativePath)) {
                throw new Error(`relativePath "${relativePath}" outside of bounds.`);
            }
            const targetPathAbs = path.resolve(destPathAbs, relativePath);
            fs_extra_1.ensureDirSync(path.dirname(targetPathAbs));
            fs_1.copyFileSync(fileAbs, targetPathAbs);
        });
    });
}
exports.copyTreeSync = copyTreeSync;
